#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <strings.h>

#define NIL NULL
#define SMALLEST -1
  
  
  typedef struct bintree
{
  int key;
  char *data;
  struct bintree *left, *right;
};

struct bintree *inforoot;

struct bintree *makenode()
{
  struct bintree *retval=(struct bintree *)malloc(sizeof(struct bintree));
  retval->left=NIL;
  retval->right=NIL;
  retval->key=SMALLEST;
  return(retval);
}


insert_node(root, key, data)
     struct bintree *root;
     char *data;
     int key;
{
  struct bintree **nodehead=&(root->right);
  while ((*nodehead)!=NIL && ((*nodehead)->key!=key))
    nodehead= (( (*(*nodehead)).key)<key) ? &((*(*nodehead)).left):&((*(*nodehead)).right);
  if (*nodehead==NIL)
    *nodehead=makenode();
  (*nodehead)->key=key;
  (*nodehead)->data=data;
}

struct bintree *find_node(root, key)
     struct bintree *root;
     int key;
{
  struct bintree **nodehead=&(root->right);
  while ((*nodehead)!=NIL && ((*nodehead)->key!=key))
    nodehead= (( (*(*nodehead)).key)<key) ? &((*(*nodehead)).left):&((*(*nodehead)).right);
  return(*nodehead);
}



int noteof(file)
     FILE *file;
{
  return(!feof(file));
};

struct bintree *read_infofile(name)
     char * name;
{
  FILE *infile;
  int flag=1, n, cur_key;
  struct bintree *myroot=makenode();
  char *cur_line;
  infile = fopen(name, "r");
  if (infile)
    while(noteof(infile))
      {
	cur_line=(char *)malloc(80);
	while (noteof(infile)&&(0==fscanf(infile, "%x%*c%*[ ]%[^\n]", &cur_key, cur_line)))
	fscanf(infile, "%*[^\n]");
	if(noteof(infile))
	  {
	    insert_node(myroot, cur_key, cur_line);
	    
	  }
      }
  else
    printf("I told you to have a 'hpint' file!\nBut there is none..\n");
  return(myroot);
}





char *get_infostr(key)
     int key;
{
  struct bintree *found_node;
  found_node=find_node(inforoot, key);
  if (found_node==NIL)
    return("Not found");
  else
    return( found_node->data );
}
     

void init_info()
{
  printf("Reading info\n");
  inforoot=read_infofile("hpint");
  
}











