#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "unthread.h"
  
unsigned char *myfilearr;	/* global array for file */
int indentlevel=0, myoffset;			/* offset in nybbles */



#define PROLOG_NOS 25

struct 
{
  char *name, *printname;
  int addr, no;
} prologinfo[PROLOG_NOS] =
{
  { "UNKNOWN"      ,"\n"    , NULL , -1 },
  { "SYSTEM_BINARY",""      , SYSTEM_BINARY      , 20  },
  { "REAL_NUMBER"  ,""      , REAL_NUMBER        , 0   },
  { "LONG_REAL"    ,""      , LONG_REAL          , 21  },
  { "COMPLEX"      ,""      , COMPLEX            , 1   },
  { "LONG_COMPLEX" ,""      , LONG_COMPLEX       , 22  },
  { "CHARACTER"    ,"\n"      , CHARACTER          , 24  },
  { "ARRAY"        ,"\n"    , ARRAY              , 3   },
  { "LINKED_ARRAY" ,""      , LINKED_ARRAY       , 23  },
  { "STRING"       ,"\n"    , STRING             , 2   },
  { "BINARY_INT"   ,"\n"      , BINARY_INT         , 10  },
  { "LIST"         ,"{\n"   , LIST               , 5   },
  { "DIRECTORY"    ,"DIR\n" , DIRECTORY          , 15  },
  { "ALGEBRAIC"    ,"\n"      , ALGEBRAIC          , 9   },
  { "UNIT"         ,"\n"      , UNIT               , 13  },
  { "TAGGED"       ,""      , TAGGED             , 12  },
  { "GRAPHIC"      ,"\n"    , GRAPHIC            , 11  },
  { "LIBRARY"      ,"\n"    , LIBRARY            , 16  },
  { "BACKUP"       ,"\n"      , BACKUP             , 17  },
  { "LIBRARY_DATA" ,"\n"      , LIBRARY_DATA       , 26  },
  { "PROGRAM"      ,"<<\n"  , PROGRAM            , 8   },
  { "CODE"         ,"\n"      , CODE               , 25  },
  { "GLOBAL_NAME"  ,""      , GLOBAL_NAME        , 6   },
  { "LOCAL_NAME"   ,""      , LOCAL_NAME         , 7   },
  { "XLIB_NAME"    ,""      , XLIB_NAME          , 14  }
};



unsigned char swap_n(c)
     unsigned char c;
{
  return((c>>4)+(c<<4));
}

void aargh(str)
     char *str;
{
  printf("%s %s",str,"\nExiting.\n");

  exit(0);
}

int readin(name)
     char *name;
{
  int myfilesize;
  FILE *infile;
  int filed;
  struct stat buf;
  unsigned char *tfp;
  int tempc;			
  if ((filed = open(name,O_RDONLY))==-1) 
     aargh("Could not open file\n");
  if (fstat(filed, &buf)==-1)
    aargh("fstat error\n");
  printf("reading %u bytes\n",buf.st_size);
  if (!(myfilearr=(unsigned char *)malloc((unsigned)(myfilesize=(long)buf.st_size))))
    aargh("Could not allocate memory\n");
  tfp=myfilearr;
  infile=fdopen(filed, "r");
  while ((tempc=fgetc(infile))!=EOF)
    {
      tempc=(char)0xff&tempc;
      *(tfp++)=swap_n(tempc);
    }
  
  printf("File read ok\n");
  return(myfilesize);
}

unsigned char get_n(start, offset)
     int offset;
     unsigned char*start;
{
  unsigned char retval;
  retval=*(start+(offset>>1));
  retval=offset&0x1?retval&0xf:((retval&0xf0)>>4);
  return(retval);
}

int get_bin5(start,offset)
     int offset;
     unsigned char *start;
{
  int retval=0, loop;
  for(loop=0; loop<5; loop++)
    {
      
      retval+=(get_n(start,offset+loop)<<(4*loop));
      
    }
  return(retval);
}

int get_bin2(start,offset)
     int offset;
     unsigned char *start;
{
  int retval=0, loop;
  for(loop=0; loop<2; loop++)
    {
      
      retval+=(get_n(start,offset+loop)<<(4*loop));
      
    }
  return(retval);
}

int get_binx(binxstart, offset, nonib)
     unsigned char *binxstart;
     int offset,nonib;
{
  int retval=0, loop;
  for(loop=0; loop<nonib; loop++)
    {
      
      retval+=(get_n(binxstart,offset+loop)<<(4*loop));
      
    }
  return(retval);
}

int print_hps(start, offset, length)
     unsigned char *start;
     int offset, length;
{
  int loop;
  for (loop=0; loop<(length*2); loop+=2)
    {
      printf ("%c",get_binx(start, offset+loop, (int)2));
    }
  return(length*2);
}

int find_prolog(prolog)
     int prolog;
{
  int loop;
  
  for (loop=1; loop<PROLOG_NOS; loop++)
    if (prologinfo[loop].addr==prolog) return(loop);
  return(0);			/* unsuccesful */
}


int print_size(start, offset)
     unsigned char *start;
     int offset;
{
  print_beg(start, offset, 5, "size", FORCE_NL);  
  return(5);
}

int print_ascix(start, offset)
     unsigned char *start;
     int offset;
{
  int strlen=get_bin2(start, offset);
  if (strlen!=0)
    {
      printf("'");
      print_hps(start, offset+2, strlen);
      puts("'");
      return(4+strlen*2);
    }
  else
    {
      printf("''\n");
      return(2);
    }
}

int print_ascic(start, offset)
     unsigned char *start;
     int offset;
{
  int strlen=get_bin2(start, offset);
  if (strlen!=0)
    {
      printf("'");
      print_hps(start, offset+2, strlen);
      puts("'");
      return(2+strlen*2);
    }
  else
    {
      printf("''\n");
      return(2);
    }
}


void pr_infh(n)
     int n;
{
  printf(" ");
  n=INFOFIELD_L-n-1+12;
  while((n--)>0)
    printf("-");
  printf("+\n");
}


int print_string(start, offset)
     unsigned char *start;
     int offset;
{
  int length=get_binx(start, offset, 5);
  print_size(start, offset);
  print_beg(start, offset+5, 5, "strdat", indentlevel);
  printf("\"");
  print_hps(start, offset+5, (length-5)/2);
  printf("\"\n");
  return(length);
}

int print_binint(start, offset)
     unsigned char *start;
     int offset;
{
  int loop, length=get_bin5(start, offset);
  
  offset+=print_size(start, offset);
  print_beg(start, offset, 5, "binintdata", indentlevel);
  printf("#");
  for(loop=0; loop<(length-5); loop++)
    printf("%X", get_n(start, offset+loop));
  printf("h\n");
  return(length);
}

int print_real(start, offset)
     unsigned char *start;
     int offset;
{
  offset=print_realx(start, offset, REAL_FORM12);
  printf("\n");
  return offset;
}



int print_realx(start, offset, length)
     unsigned char *start;
     int offset, length;
{
  int loop;
  float cf;
  char gonzaga[20];
  char *gonz=gonzaga;
  if (get_n(start, offset+length-1)==MAGIC_MINUS)
    sprintf(gonz++, "-");
  sprintf(gonz, "%X.", get_n(start, offset+length-2));
  gonz+=2;
  for(loop=length-3; loop>=0; loop--)
    {
      if (loop==2)
	sprintf(gonz++, "E");
	
      sprintf(gonz++, "%X", get_n(start, offset+loop));
    }
  sscanf(gonzaga, "%f", &cf);
  printf("%g", cf);
  printf(" ");
  return(length);
}
	   

int print_complex(start, offset)
     unsigned char *start;
     int offset;
{
  return(print_complexx(start, offset, REAL_FORM12));
}

int print_complexx(start, offset, form)
     unsigned char *start;
     int offset, form;
{
  printf("Re:");
  offset+=print_realx(start, offset, form);
  printf("Im:");
  offset+=print_realx(start, offset, form);
  
  return(2*form);
}


int print_graphic(start, offset)
     unsigned char *start;
     int offset;
{
  int  rows, cols, length;
  print_size(start, offset);
  length=get_bin5(start, offset);
  offset+=5;
  print_beg(start, offset, 5, "#rows", FORCE_NL);
  rows=get_bin5(start, offset);
  offset+=5;
  print_beg(start, offset, 5, "#columns", FORCE_NL);
  cols=get_bin5(start, offset);
  offset+=5;
  print_beg(start, offset, 5, "grdat", FORCE_NL);
  pr_infh(WHOLE_INFOFIELD);
  print_sillygraph(start, offset, rows, cols);
  pr_infh(WHOLE_INFOFIELD);
  return(length);
}

int print_sillygraph(start, offset, rows, cols)
     unsigned char *start;
     int offset, rows, cols;
{
  int rowloop, colloop, nloop,  nstr;
  cols=cols/4+((cols%4)?1:0);
  cols=cols+((cols%2)?1:0);
  for (rowloop=0; rowloop<rows; rowloop++)
    {
      for (colloop=0; colloop<cols; colloop++)
	{
	  nstr=get_n(start, offset++);
	  for (nloop=0; nloop<4; nloop++)
	    if (nstr&(1<<nloop))
	      printf("#");
	    else
	      printf(" ");
	}
      puts("");
    }
  puts("");
}
	
int print_librarydata(start, offset)
     unsigned char *start;
     int offset;
{
  int oldoffs=offset;
  offset+=print_size(start, offset);
  offset+=print_beg(start, offset, 3, "libno", FORCE_NL);
  offset+=print_beg(start, offset, 2, "datano", FORCE_NL);
  
  while (get_binx(start, offset, 5)!=END_OF_LIBRARYDATA)
    offset+=print_block(start, offset);
  offset+=print_beg(start, offset, 5,"endlibdat", FORCE_NL);
  return(offset-oldoffs);
}


  
void print_spx(no)
     int no;
{
  while((no--)>0)
    putchar(32);
}


int print_beg(start, offset, nybbles, typestr, ind)
     int  offset, nybbles, ind;
     char *typestr;
     unsigned char *start;
{
  printf("%05.X:%05.X %s", offset, get_binx(start, offset, nybbles) , typestr);
  print_spx(INFOFIELD_L-strlen(typestr));
  printf("|");
  if (ind==FORCE_NL)
      puts("");
  else
      print_spx(ind);

  return(nybbles);
      
}
    
int print_algebraic(start, offset)
     unsigned char *start;
     int offset;
{
  int old_off=offset;
  while (get_binx(start, offset, 5)!=END_OF_ALGEBRAIC)
    offset+=print_block(start, offset);
  offset+=print_beg(start, offset, 5,"endalg", indentlevel);puts("");
  return offset-old_off;
}
int print_obj(start, offset, cur_prolog)
     unsigned char *start;
     int offset, cur_prolog;
{
  int print_block();
  int print_arry();
  int endoffs, oldoffs=offset;

  switch (cur_prolog)
    {
    case BACKUP :
      offset+=print_size(start, offset);
      print_beg(start, offset, 5, "backupname", indentlevel);
      offset+=print_ascix(start, offset);
      offset+=print_block(start, offset);
      break;
    case DIRECTORY :
      offset+=print_beg(start, offset, 3, " attach", FORCE_NL);
      (void)print_beg(start, offset, 5, " offset1", FORCE_NL);
      endoffs=offset+get_binx(start, offset, 5);
      offset+=5;
      do
	{
	  offset+=print_beg(start, offset, 5, " offset", FORCE_NL);
	  print_beg(start, offset, 5, "DIRENTRY", indentlevel);
	  offset+=print_ascix(start, offset);
	  offset+=print_block(start, offset);
	}
      while (offset < endoffs  );
      break;
      
    case BINARY_INT :
      offset+=print_binint(start, offset);
      break;
    case LIST:
      while (get_binx(start, offset, 5)!=END_OF_LIST)
	offset+=print_block(start, offset);
      offset+=print_beg(start, offset, 5,"endlist", indentlevel);
      printf("}\n");
      break;
    case PROGRAM:
      while (get_binx(start, offset, 5)!=END_OF_PROGRAM)
	offset+=print_block(start, offset);
      offset+=print_beg(start, offset, 5,"endprog", indentlevel);
      printf(">>\n");
      break;
    case LOCAL_NAME:
      offset+=print_ascic(start, offset);
      break;
    case GLOBAL_NAME:
      offset+=print_ascic(start, offset);
      break;
    case STRING:
      offset+=print_string(start, offset);
      break;
    case REAL_NUMBER:
      offset+=print_real(start, offset);
      break;
    case COMPLEX:
      offset+=print_complex(start, offset);
      break;
    case LONG_REAL:
      offset+=print_realx(start, offset, REAL_FORM15);
      break;
    case LONG_COMPLEX:
      offset+=print_complexx(start, offset, REAL_FORM15);
      break;
    case ARRAY:
      offset+=print_array(start, offset);
      break;
    case LIBRARY :
      offset+=print_library(start, offset);
      break;
    case XLIB_NAME :
      offset+=print_xlibname(start, offset);
      break;
    case SYSTEM_BINARY :
      printf("<%x>\n", get_bin5(start, offset));
      offset+=5;
      break;
    case CODE :
      print_size(start, offset);
      offset+=get_bin5(start, offset);
      printf("No dissasembly yet!\n");
      break;
    case GRAPHIC :
      offset+=print_graphic(start, offset);
      break;
    case CHARACTER :
      print_beg(start, offset, 2, "char", indentlevel);
      printf("'%c'\n", get_binx(start, offset, 2));
      offset+=2;
      break;
    case LINKED_ARRAY :
      print_beg(start, offset, 5, "size", indentlevel);
      printf("I dont know how to display this form.\n");
      offset+=get_bin5(start, offset);
    case ALGEBRAIC :
      offset+=print_algebraic(start, offset);
      break;
    case LIBRARY_DATA :
      offset+=print_librarydata(start, offset);
      break;
    case TAGGED :
      offset+=print_ascic(start, offset);
      offset+=print_block(start, offset);
      break;
    case UNIT :
      offset+=print_block(start, offset);
      offset+=print_block(start, offset);
      while (get_binx(start, offset, 5)!=END_OF_TAG)
	offset+=print_block(start, offset);
      offset+=print_beg(start, offset, 5,"endunit", FORCE_NL);
      break;
    }
  return(offset-oldoffs);
}


int print_array(start, offset)
     unsigned char *start;
     int offset;
{
  int  cur_prolog_no, length, obj_nos=1, dims, cur_prolog;
  print_size(start, offset);
  length=get_bin5(start, offset);
  offset+=5;
  cur_prolog=get_bin5(start, offset);
  cur_prolog_no=find_prolog(cur_prolog);
  print_beg(start, offset, 5, prologinfo[cur_prolog_no].name , FORCE_NL);
  offset+=5;
  print_beg(start, offset, 5, "#dims ", FORCE_NL);
  dims=get_bin5(start, offset); offset+=5;
  while(dims--)
    {
      print_beg(start, offset, 5, "dim", FORCE_NL);
      obj_nos*=get_bin5(start, offset);
      offset+=5;
    }
  pr_infh(printf("-- array start"));
  while(obj_nos--)
    offset+=print_obj(start, offset, cur_prolog);
  pr_infh(printf("\n-- array end"));
  return(length);
}

int print_xlibname(start, offset)
     unsigned char *start;
     int offset;
{
  char *istr;
  istr=get_infostr(get_binx(start,offset,6));
  
  printf("XLIB %03x %03x\t%s\n", get_binx(start, offset, 3), get_binx(start, offset+3, 3), (*istr=='~')?istr:"");
  return(XLIBNAME_L);
}



int print_library(start, offset)
     unsigned char *start;
     int offset;
{
  int *linkme, *linkbase, oldoffs=offset;
  int  lts, nts, loop, loop2;
  struct {
    int libno, hashoffs, msgoffs, linkoffs, configoffs
    } libinfo;
  int length=get_bin5(start, offset);
  offset+=print_size(start, offset);
  print_beg(start, offset, 5, "libname", indentlevel);
  offset+=print_ascix(start, offset);
  print_beg(start, offset, 3, "libnum", FORCE_NL);
  libinfo.libno=get_binx(start, offset, 3);
  offset+=3;

  print_beg(start, offset, 5, "hash", FORCE_NL);
  libinfo.hashoffs=get_bin5(start, offset)+offset;
  offset+=5;
  
  print_beg(start, offset, 5, "msg", FORCE_NL);
  libinfo.msgoffs=get_bin5(start, offset)+offset;
  offset+=5;
  
  print_beg(start, offset, 5, "link", FORCE_NL);
  libinfo.linkoffs=get_bin5(start, offset)+offset;
  offset+=5;
  
  print_beg(start, offset, 5, "config", FORCE_NL);
  libinfo.configoffs=get_bin5(start, offset)+offset;
  offset+=5;
  
  if (libinfo.msgoffs!=0x24+oldoffs)
    {
      pr_infh(printf("-- msg table"));
      print_block(start, libinfo.msgoffs);
    }

  pr_infh(printf("-- hash table"));
  libinfo.hashoffs+=print_beg(start, libinfo.hashoffs, 5, "hashtable", FORCE_NL);
  libinfo.hashoffs+=print_size(start, libinfo.hashoffs);
  for (loop=0; loop<16; loop++)
    {
      print_beg(start, libinfo.hashoffs, 5, "hashoffs", indentlevel);
      printf("Entry %x", loop);
      if (get_bin5(start, libinfo.hashoffs) != 0)
	printf(" at %x\n", libinfo.hashoffs+get_bin5(start, libinfo.hashoffs));
      else
	printf(" nonexistant\n");
      libinfo.hashoffs+=5;
    }
  pr_infh(printf("-- name table"));
  print_size(start, libinfo.hashoffs);
  nts=libinfo.hashoffs+get_bin5(start, libinfo.hashoffs);
  libinfo.hashoffs+=5;
  while(nts>libinfo.hashoffs)
    {
      print_beg(start, offset, 5, "name entry", indentlevel);
      libinfo.hashoffs+=print_ascic(start, libinfo.hashoffs);
      libinfo.hashoffs+=print_beg(start, libinfo.hashoffs, 3, "xlib", FORCE_NL);
    }
  pr_infh(printf("-- Config for XLIB %dd", libinfo.libno));
  print_block(start, libinfo.configoffs);

  pr_infh(printf("-- link table"));
  libinfo.linkoffs+=print_beg(start, libinfo.linkoffs, 5, "linktable", FORCE_NL);
  print_size(start, libinfo.linkoffs);
  lts=get_bin5(start, libinfo.linkoffs);
  linkbase=(int *)malloc((lts/5)*sizeof(int));
  linkme=linkbase;
  libinfo.linkoffs+=5;
  loop=0;
  while((lts-=5)>0)
    {
      print_beg(start, libinfo.linkoffs, 5, "linkoffs", indentlevel);
      *linkme++=(get_bin5(start, libinfo.linkoffs)+libinfo.linkoffs)&FIVENYBLES;
      printf("xlib %dd at %X\n", loop,*(linkme-1));
      libinfo.linkoffs+=5;
      loop++;
    }
  linkme=linkbase;
  for (loop2=0; loop2<loop; loop2++)
    {
      pr_infh(printf("-- Code for XLIB %dd %dd", libinfo.libno, loop2));
      print_block(start, *linkme++);
    }
  free(linkbase);
  return(length);
}
	  


int print_block(start, offset)
     unsigned char *start;
     int offset;
{
  int  oldoff=offset;
  int cur_prolog=get_bin5(start, offset);
  int cur_prolog_no=find_prolog(cur_prolog);
  indentlevel+=2;

  if (cur_prolog_no!=0)
    {
      print_beg(start, offset, 5, prologinfo[cur_prolog_no].name , indentlevel);
      printf("%s", prologinfo[cur_prolog_no].printname);
      offset+=5;
      offset+=print_obj(start, offset, cur_prolog);
    }
  else
    {
      print_beg(start, offset, 5, "romobj" , indentlevel);
      printf("%s", get_infostr(cur_prolog));
      puts("");
      offset+=5;

    }
  indentlevel-=2;
  return(offset-oldoff);
}


main(argc,argv)
     int argc;
     char *argv[];
{
  int retval, filesize=0;
  init_info();

  if (argc==2) 
    printf("Scanning %s\n", argv[1]);
  else
    printf("erraneous arguments\n");
  filesize=readin(argv[1]);
  myoffset+=print_hps(myfilearr, myoffset,  8);
  printf("\t");
  myoffset+=print_ascic(myfilearr, myoffset);
  while ((2*filesize)>myoffset)
    {
      myoffset+=print_block(myfilearr, myoffset);
    }
  printf("\n\n####END\n");
}

